/*******************************************************************************
 * File name: IntelJ3.h
 * Description: Flash Burner
 * Author: Shiva
 * Revision history:
 * 2010/10/01	Create this file.
 * ****************************************************************************/
#ifndef __IntelJ3__
#define __IntelJ3__

#include "util.h"

#define MX_Type     (0x01)
#define SST_Type    (0x02)
#define Intel_Type  (0x03)
#define AMD_Type    (0x04)

#define FLASH_SINGLE (0x00)
#define FLASH_DOUBLE (0x01)
#define FLASH_FOUR   (0x02)

#define BLK_SIZE	0x40000
#define FLASH_SIZE  	0x2000000

/* Flash programming function */
void Flash_ReadID(unsigned flash_type, unsigned base, unsigned BusWidth, unsigned* DDI1, unsigned* DDI2);
void Flash_Reset(unsigned base, unsigned BusWidth);
void Flash_ChipErase(unsigned flash_type, unsigned base, unsigned BusWidth);
void Flash_ProgramByte(unsigned flash_type, unsigned base, unsigned address, UINT8 data);
void Flash_ProgramHalfWord(unsigned flash_type, unsigned base, unsigned address, UINT16 data);
void Flash_ProgramWord(unsigned flash_type, unsigned base, volatile unsigned address, volatile unsigned data);
void Flash_ProgramMultiWord(unsigned flash_type, unsigned base, volatile unsigned address, unsigned char *buffer, unsigned size);
int Burn_image(unsigned flash_type, unsigned int address, unsigned char* start, unsigned int size, unsigned int base);

unsigned int usage(void);
/* option structure */
static struct option long_option[] = 
{
  {"h", no_argument, 0, 'h'},
  {"help", no_argument, 0, 'h'},
  {"preserve", no_argument, 0, 'e'},
  {"reset-target", no_argument, 0, 't'},
  {"reset-hold", no_argument, 0, 'o'},
  {"target", required_argument, 0, 'x'},
  {"lock", no_argument, 0, 'z'},
  {"unlock", no_argument, 0, 'y'},
  {"verify", no_argument, 0, 'v'},
  {"verify-only", no_argument, 0, 'c'},
  {"source", no_argument, 0, 's'},
  {"version", no_argument, 0, 'V'},
  {"fast", no_argument, 0, 'g'},
  {"erase-all", no_argument, 0, 'u'},
  {"reset-hold", no_argument, 0, 'o'},
  {"force", no_argument, 0, 'F'},
  {"log", required_argument, 0, 'l'},
  {"p", required_argument, 0, 'p'},
  {"port", required_argument, 0, 'p'},
  {"a", required_argument, 0, 'a'},
  {"addr", required_argument, 0, 'a'},
  {"f", required_argument, 0, 'f'},
  {"flash", required_argument, 0, 'f'},
  {"b", required_argument, 0, 'b'},
  {"base", required_argument, 0, 'b'},
  {"i", required_argument, 0, 'i'},
  {"image", required_argument, 0, 'i'},
  {0, 0, 0, 0}
};
#endif

