/*******************************************************************************
 * File name: util.h
 * Description: Flash Burner
 * Author: Shiva
 * Revision history:
 * 2010/10/01	Create this file.
 * ****************************************************************************/
#ifndef __UTIL__
#define __UTIL__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <getopt.h>

#ifdef __MINGW32__
#include <winsock2.h>
#undef socklen_t
#define socklen_t int
#define sleep(t) _sleep(t * 1000)
#else
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

#ifdef __MINGW32__
#define    SEND(SOCKET, DATA, SIZE) send(SOCKET, DATA, SIZE, 0);
#define    RECV(SOCKET, DATA, SIZE) recv(SOCKET, DATA, SIZE, 0);
#else
#define    SEND(SOCKET, DATA, SIZE) write(SOCKET, DATA, SIZE);
#define    RECV(SOCKET, DATA, SIZE) read(SOCKET, DATA, SIZE);
#endif

#define RESET_TARGET (0x3a)
#define RESET_HOLD   (0x3b)
#define RESET_AICE   (0x3c)
#define HOLD_CORE    (0x1d)

/* type define */
typedef unsigned long long      UINT64;
typedef long long                       INT64;
typedef unsigned int            UINT32;
typedef int                                     INT32;
typedef unsigned short          UINT16;
typedef short                           INT16;
typedef unsigned char           UINT8;
/*typedef char                            INT8; */

/* read/write API */
int outw(unsigned int address, unsigned int data);
unsigned int inw(unsigned int address);
int fastin(unsigned int address, unsigned int size, char * buffer);
int fastout(unsigned int address, unsigned int size, char * buffer);

int Verification(unsigned int address, unsigned char* start, unsigned int size);
int Record_content(unsigned int address,unsigned char* buffer, unsigned int size);

void terminate(void);
void handle_int(int signo);
int send_cmd(char cmd);

void initial_socket(unsigned int port);
/* get image from file */
unsigned char* get_image(FILE* image, unsigned int* size);

/* SOC relative functions */
unsigned int xc5(void);
unsigned int p24(void);
unsigned int ag301p(void);
unsigned int ag101(void);

#endif

